import { ATN, CharStream, DFA, Lexer } from "antlr4";
export default class CypherLexer extends Lexer {
    static readonly SPACE = 1;
    static readonly SINGLE_LINE_COMMENT = 2;
    static readonly DECIMAL_DOUBLE = 3;
    static readonly UNSIGNED_DECIMAL_INTEGER = 4;
    static readonly UNSIGNED_HEX_INTEGER = 5;
    static readonly UNSIGNED_OCTAL_INTEGER = 6;
    static readonly ACCESS = 7;
    static readonly ACTIVE = 8;
    static readonly ADMIN = 9;
    static readonly ADMINISTRATOR = 10;
    static readonly ALIAS = 11;
    static readonly ALIASES = 12;
    static readonly ALL_SHORTEST_PATH = 13;
    static readonly ALL = 14;
    static readonly ALTER = 15;
    static readonly AND = 16;
    static readonly ANY = 17;
    static readonly ARRAY = 18;
    static readonly AS = 19;
    static readonly ASC = 20;
    static readonly ASSERT = 21;
    static readonly ASSIGN = 22;
    static readonly AT = 23;
    static readonly BAR = 24;
    static readonly BINDINGS = 25;
    static readonly BOOL = 26;
    static readonly BOOLEAN = 27;
    static readonly BOOSTED = 28;
    static readonly BREAK = 29;
    static readonly BRIEF = 30;
    static readonly BTREE = 31;
    static readonly BUILT = 32;
    static readonly BY = 33;
    static readonly CALL = 34;
    static readonly CASE = 35;
    static readonly CHANGE = 36;
    static readonly CIDR = 37;
    static readonly COLLECT = 38;
    static readonly COLON = 39;
    static readonly COLONCOLON = 40;
    static readonly COMMA = 41;
    static readonly COMMAND = 42;
    static readonly COMMANDS = 43;
    static readonly COMMIT = 44;
    static readonly COMPOSITE = 45;
    static readonly CONSTRAINT = 46;
    static readonly CONSTRAINTS = 47;
    static readonly CONTAINS = 48;
    static readonly COPY = 49;
    static readonly CONTINUE = 50;
    static readonly COUNT = 51;
    static readonly CREATE = 52;
    static readonly CSV = 53;
    static readonly CURRENT = 54;
    static readonly DATA = 55;
    static readonly DATABASE = 56;
    static readonly DATABASES = 57;
    static readonly DATE = 58;
    static readonly DATETIME = 59;
    static readonly DBMS = 60;
    static readonly DEALLOCATE = 61;
    static readonly DEFAULT = 62;
    static readonly DEFINED = 63;
    static readonly DELETE = 64;
    static readonly DENY = 65;
    static readonly DESC = 66;
    static readonly DESTROY = 67;
    static readonly DETACH = 68;
    static readonly DIFFERENT = 69;
    static readonly DOLLAR = 70;
    static readonly DISTINCT = 71;
    static readonly DIVIDE = 72;
    static readonly DOT = 73;
    static readonly DOTDOT = 74;
    static readonly DRIVER = 75;
    static readonly DROP = 76;
    static readonly DRYRUN = 77;
    static readonly DUMP = 78;
    static readonly DURATION = 79;
    static readonly EACH = 80;
    static readonly EDGE = 81;
    static readonly ENABLE = 82;
    static readonly ELEMENT = 83;
    static readonly ELEMENTS = 84;
    static readonly ELSE = 85;
    static readonly ENCRYPTED = 86;
    static readonly END = 87;
    static readonly ENDS = 88;
    static readonly EQ = 89;
    static readonly EXECUTABLE = 90;
    static readonly EXECUTE = 91;
    static readonly EXIST = 92;
    static readonly EXISTENCE = 93;
    static readonly EXISTS = 94;
    static readonly ERROR = 95;
    static readonly FAIL = 96;
    static readonly FALSE = 97;
    static readonly FIELDTERMINATOR = 98;
    static readonly FLOAT = 99;
    static readonly FOR = 100;
    static readonly FOREACH = 101;
    static readonly FROM = 102;
    static readonly FULLTEXT = 103;
    static readonly FUNCTION = 104;
    static readonly FUNCTIONS = 105;
    static readonly GE = 106;
    static readonly GRANT = 107;
    static readonly GRAPH = 108;
    static readonly GRAPHS = 109;
    static readonly GROUP = 110;
    static readonly GROUPS = 111;
    static readonly GT = 112;
    static readonly HEADERS = 113;
    static readonly HOME = 114;
    static readonly IF = 115;
    static readonly IMPERSONATE = 116;
    static readonly IMMUTABLE = 117;
    static readonly IN = 118;
    static readonly INDEX = 119;
    static readonly INDEXES = 120;
    static readonly INF = 121;
    static readonly INFINITY = 122;
    static readonly INT = 123;
    static readonly INTEGER = 124;
    static readonly IS = 125;
    static readonly JOIN = 126;
    static readonly KEY = 127;
    static readonly LABEL = 128;
    static readonly LABELS = 129;
    static readonly AMPERSAND = 130;
    static readonly EXCLAMATION_MARK = 131;
    static readonly LBRACKET = 132;
    static readonly LCURLY = 133;
    static readonly LE = 134;
    static readonly LIMITROWS = 135;
    static readonly LIST = 136;
    static readonly LOAD = 137;
    static readonly LOCAL = 138;
    static readonly LOOKUP = 139;
    static readonly LPAREN = 140;
    static readonly LT = 141;
    static readonly MANAGEMENT = 142;
    static readonly MAP = 143;
    static readonly MATCH = 144;
    static readonly MERGE = 145;
    static readonly MINUS = 146;
    static readonly PERCENT = 147;
    static readonly NEQ = 148;
    static readonly NEQ2 = 149;
    static readonly NAME = 150;
    static readonly NAMES = 151;
    static readonly NAN = 152;
    static readonly NEW = 153;
    static readonly NODE = 154;
    static readonly NODES = 155;
    static readonly NONE = 156;
    static readonly NOT = 157;
    static readonly NOTHING = 158;
    static readonly NOWAIT = 159;
    static readonly NULL = 160;
    static readonly OF = 161;
    static readonly ON = 162;
    static readonly ONLY = 163;
    static readonly OPTIONAL = 164;
    static readonly OPTIONS = 165;
    static readonly OPTION = 166;
    static readonly OR = 167;
    static readonly ORDER = 168;
    static readonly OUTPUT = 169;
    static readonly PASSWORD = 170;
    static readonly PASSWORDS = 171;
    static readonly PATH = 172;
    static readonly PATHS = 173;
    static readonly PERIODIC = 174;
    static readonly PLAINTEXT = 175;
    static readonly PLUS = 176;
    static readonly PLUSEQUAL = 177;
    static readonly POINT = 178;
    static readonly POPULATED = 179;
    static readonly POW = 180;
    static readonly PRIMARY = 181;
    static readonly PRIMARIES = 182;
    static readonly PRIVILEGE = 183;
    static readonly PRIVILEGES = 184;
    static readonly PROCEDURE = 185;
    static readonly PROCEDURES = 186;
    static readonly PROPERTIES = 187;
    static readonly PROPERTY = 188;
    static readonly QUESTION = 189;
    static readonly RANGE = 190;
    static readonly RBRACKET = 191;
    static readonly RCURLY = 192;
    static readonly READ = 193;
    static readonly REALLOCATE = 194;
    static readonly REDUCE = 195;
    static readonly RENAME = 196;
    static readonly REGEQ = 197;
    static readonly REL = 198;
    static readonly RELATIONSHIP = 199;
    static readonly RELATIONSHIPS = 200;
    static readonly REMOVE = 201;
    static readonly REPEATABLE = 202;
    static readonly REPLACE = 203;
    static readonly REPORT = 204;
    static readonly REQUIRE = 205;
    static readonly REQUIRED = 206;
    static readonly RETURN = 207;
    static readonly REVOKE = 208;
    static readonly ROLE = 209;
    static readonly ROLES = 210;
    static readonly ROW = 211;
    static readonly ROWS = 212;
    static readonly RPAREN = 213;
    static readonly SCAN = 214;
    static readonly SEC = 215;
    static readonly SECOND = 216;
    static readonly SECONDARY = 217;
    static readonly SECONDARIES = 218;
    static readonly SECONDS = 219;
    static readonly SEEK = 220;
    static readonly SEMICOLON = 221;
    static readonly SERVER = 222;
    static readonly SERVERS = 223;
    static readonly SET = 224;
    static readonly SETTING = 225;
    static readonly SETTINGS = 226;
    static readonly SHORTEST_PATH = 227;
    static readonly SHORTEST = 228;
    static readonly SHOW = 229;
    static readonly SIGNED = 230;
    static readonly SINGLE = 231;
    static readonly SKIPROWS = 232;
    static readonly START = 233;
    static readonly STARTS = 234;
    static readonly STATUS = 235;
    static readonly STOP = 236;
    static readonly STRING = 237;
    static readonly SUPPORTED = 238;
    static readonly SUSPENDED = 239;
    static readonly TARGET = 240;
    static readonly TERMINATE = 241;
    static readonly TEXT = 242;
    static readonly THEN = 243;
    static readonly TIME = 244;
    static readonly TIMES = 245;
    static readonly TIMESTAMP = 246;
    static readonly TIMEZONE = 247;
    static readonly TO = 248;
    static readonly TOPOLOGY = 249;
    static readonly TRANSACTION = 250;
    static readonly TRANSACTIONS = 251;
    static readonly TRAVERSE = 252;
    static readonly TRUE = 253;
    static readonly TYPE = 254;
    static readonly TYPED = 255;
    static readonly TYPES = 256;
    static readonly UNION = 257;
    static readonly UNIQUE = 258;
    static readonly UNIQUENESS = 259;
    static readonly UNWIND = 260;
    static readonly URL = 261;
    static readonly USE = 262;
    static readonly USER = 263;
    static readonly USERS = 264;
    static readonly USING = 265;
    static readonly VALUE = 266;
    static readonly VARCHAR = 267;
    static readonly VERBOSE = 268;
    static readonly VERTEX = 269;
    static readonly WAIT = 270;
    static readonly WHEN = 271;
    static readonly WHERE = 272;
    static readonly WITH = 273;
    static readonly WITHOUT = 274;
    static readonly WRITE = 275;
    static readonly XOR = 276;
    static readonly YIELD = 277;
    static readonly ZONED = 278;
    static readonly EXPLAIN = 279;
    static readonly PROFILE = 280;
    static readonly IDENTIFIER = 281;
    static readonly ErrorChar = 282;
    static readonly ARROW_LINE = 283;
    static readonly ARROW_LEFT_HEAD = 284;
    static readonly ARROW_RIGHT_HEAD = 285;
    static readonly FORMAL_COMMENT = 286;
    static readonly STRING_LITERAL1 = 287;
    static readonly STRING_LITERAL2 = 288;
    static readonly MULTI_LINE_COMMENT = 289;
    static readonly ESCAPED_SYMBOLIC_NAME = 290;
    static readonly MORE1 = 291;
    static readonly STRING1_OPEN = 292;
    static readonly STRING2_OPEN = 293;
    static readonly ESCAPED_SYMBOLIC_NAME_OPEN = 294;
    static readonly MORE3 = 295;
    static readonly MORE4 = 296;
    static readonly MORE5 = 297;
    static readonly MORE6 = 298;
    static readonly MORE7 = 299;
    static readonly MORE8 = 300;
    static readonly MORE9 = 301;
    static readonly MORE10 = 302;
    static readonly MORE11 = 303;
    static readonly MORE24 = 304;
    static readonly EOF: number;
    static readonly IN_FORMAL_COMMENT = 1;
    static readonly STRING1 = 2;
    static readonly STRING2 = 3;
    static readonly IN_MULTI_LINE_COMMENT = 4;
    static readonly ESC_SYMB_NAME = 5;
    static readonly IN_SINGLE_LINE_COMMENT = 6;
    static readonly channelNames: string[];
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    constructor(input: CharStream);
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    get channelNames(): string[];
    get modeNames(): string[];
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): ATN;
    static DecisionsToDFA: DFA[];
}
